
// +----------------------------------------------------------------------------------------+ //
// |    .-._______                           XARD777                          _______.-.    | //
// |---( )_)______)                 Knowledge of the ancients                (______(_( )---| //
// |  (    ()___)                              \/                             (___()    )  | //
// |       ()__)                              (o o)                             (__()       | //
// |--(___()_)__________________________oOOo___(_)___oOOo_________________________(_()___)--| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                   2011 | //
// |----------------------------------------------------------------------------------------| //
// |                 File:     !BDP MA-MACD BARS.mq4                                        | //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 229 (current version)                              | //
// |                                                               [BILLION DOLLAR PROJECT] | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window

extern int Digit_Switch = 5;

string PassWord = "free_at_tsd";

int TF1 = 1;
int TF2 = 5;
int TF3 = 15;
int TF4 = 30;
int TF5 = 60;
int TF6 = 240;
int TF7 = 1440;


extern int Shift_UP_DN = 248;
extern int Adjust_Side_to_side = 2;
extern int Sig_Bars_Window = 0;


bool Show_Price = false;
bool Show_Xtra_Details = false;
bool Show_Smaller_Size = FALSE;
color TimeFrame_Label_color = Silver;
color BarLabel_color = Silver;
color CommentLabel_color = Silver;
color Spread_color = DarkOrange;
color HI_LO_color = DarkOrange;
color Pips_UP = Lime;
color Pips_DN = OrangeRed;
color Daily_AV_UP = Lime;
color Daily_AV_DN = OrangeRed;

color Price_UP = Lime;
color Price_DN = Red;
color Price_Neutral = Orange;

extern int MACD_Fast = 6;//12;//5;
extern int MACD_Slow = 20;//26;//8;
extern int MACD_Signal = 20;//9;//5;
extern int MACD_PRICE_TYPE = 0;

color XUP_above_0 = Lime;
color XDN_above_0 = Tomato;
color XUP_below_0 = Green;
color XDN_below_0 = Red;

int RSI_Period = 9;
int RSI_PRICE_TYPE = 0;

int CCI_Period = 13;
int CCI_PRICE_TYPE = 0;

int STOCH_K_Period = 5;
int STOCH_D_Period = 3;
int STOCH_Slowing = 3;
int STOCH_MA_MODE = 1;

color STR_UP = Lime;
color STR_DN = Red;
color STR_NO_Signal = Orange;

int MA_Fast = 1;
int MA_Slow = 20;
int MA_MODE = 0;
int MA_PRICE_TYPE = 4;

color MA_UP = Lime;
color MA_DN = Red;

int Signal(string a_name_0, int a_x_8, int a_y_12) {
   ObjectCreate(a_name_0, OBJ_LABEL, Sig_Bars_Window, 0, 0);
   ObjectSet(a_name_0, OBJPROP_CORNER, 3);
   ObjectSet(a_name_0, OBJPROP_XDISTANCE, a_x_8);
   ObjectSet(a_name_0, OBJPROP_YDISTANCE, a_y_12);
   ObjectSet(a_name_0, OBJPROP_BACK, FALSE);
   return (0);
}

int init() {
   return (0);
}

int deinit() {

   ObjectDelete("Signalprice");
   ObjectDelete("tsd_FREE");
   ObjectDelete("SIG_BARS_TF1");
   ObjectDelete("SIG_BARS_TF2");
   ObjectDelete("SIG_BARS_TF3");
   ObjectDelete("SIG_BARS_TF4");
   ObjectDelete("SIG_BARS_TF5");
   ObjectDelete("SIG_BARS_TF6");
   ObjectDelete("SIG_BARS_TF7");
   ObjectDelete("SSignalMACD_TEXT");
   ObjectDelete("SSignalMACDM1");
   ObjectDelete("SSignalMACDM5");
   ObjectDelete("SSignalMACDM15");
   ObjectDelete("SSignalMACDM30");
   ObjectDelete("SSignalMACDH1");
   ObjectDelete("SSignalMACDH4");
   ObjectDelete("SSignalMACDD1");
   ObjectDelete("SSignalSTR_TEXT");
   ObjectDelete("SignalSTRM1");
   ObjectDelete("SignalSTRM5");
   ObjectDelete("SignalSTRM15");
   ObjectDelete("SignalSTRM30");
   ObjectDelete("SignalSTRH1");
   ObjectDelete("SignalSTRH4");
   ObjectDelete("SignalSTRD1");
   ObjectDelete("SignalEMA_TEXT");
   ObjectDelete("SignalEMAM1");
   ObjectDelete("SignalEMAM5");
   ObjectDelete("SignalEMAM15");
   ObjectDelete("SignalEMAM30");
   ObjectDelete("SignalEMAH1");
   ObjectDelete("SignalEMAH4");
   ObjectDelete("SignalEMAD1");
   ObjectDelete("SIG_DETAIL_1");
   ObjectDelete("SIG_DETAIL_2");
   ObjectDelete("SIG_DETAIL_3");
   ObjectDelete("SIG_DETAIL_4");
   ObjectDelete("SIG_DETAIL_5");
   ObjectDelete("SIG_DETAIL_6");
   ObjectDelete("SIG_DETAIL_7");
   ObjectDelete("SIG_DETAIL_8");
   ObjectDelete("SB71_Password");
   ObjectDelete("SB71_Password1");
   return (0);
}

int start() {
   int li_76;
   int li_80;
   int li_84;
   int li_88;
   int li_92;
   int li_96;
   int li_100;
   color l_color_176;
   color l_color_180;
   color l_color_184;
   color l_color_188;
   color l_color_192;
   color l_color_196;
   color l_color_200;
   string ls_unused_788;
   color l_color_796;
   color l_color_800;
   color l_color_804;
   color l_color_808;
   color l_color_812;
   color l_color_816;
   color l_color_820;
   color l_color_856;
   string ls_unused_932;
   color l_color_964;
   color l_color_968;
   double l_iopen_972;
   double l_iclose_980;
   double ld_988;
   double l_ihigh_996;
   double l_ilow_1004;
   string l_text_0 = "";
   string l_text_8 = "";
   if (PassWord != "free_at_tsd") {
      l_text_0 = "Incorrect Password";
      l_text_8 = "Signal Bars v8 is free @ www.forex-tsd.com";
      ObjectDelete("SB71_Password");
      ObjectCreate("SB71_Password", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("SB71_Password", l_text_0, 60, "Arial", Red);
      ObjectSet("SB71_Password", OBJPROP_CORNER, 0);
      ObjectSet("SB71_Password", OBJPROP_XDISTANCE, 240);
      ObjectSet("SB71_Password", OBJPROP_YDISTANCE, 220);
      ObjectDelete("SB71_Password1");
      ObjectCreate("SB71_Password1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("SB71_Password1", l_text_8, 30, "Arial", Red);
      ObjectSet("SB71_Password1", OBJPROP_CORNER, 0);
      ObjectSet("SB71_Password1", OBJPROP_XDISTANCE, 200);
      ObjectSet("SB71_Password1", OBJPROP_YDISTANCE, 300);
      return (0);
   }
   l_text_0 = "";
   l_text_8 = "";
   int l_ind_counted_16 = IndicatorCounted();
   string l_text_20 = "";
   string l_text_28 = "";
   string l_text_36 = "";
   string l_text_44 = "";
   string l_text_52 = "";
   string l_text_60 = "";
   string l_text_68 = "";
   if (TF1 == PERIOD_M1) l_text_20 = "M1";
   if (TF1 == PERIOD_M5) l_text_20 = "M5";
   if (TF1 == PERIOD_M15) l_text_20 = "M15";
   if (TF1 == PERIOD_M30) l_text_20 = "M30";
   if (TF1 == PERIOD_H1) l_text_20 = "H1";
   if (TF1 == PERIOD_H4) l_text_20 = "H4";
   if (TF1 == PERIOD_D1) l_text_20 = "D1";
   if (TF1 == PERIOD_W1) l_text_20 = "W1";
   if (TF1 == PERIOD_MN1) l_text_20 = "MN";
   if (TF2 == PERIOD_M1) l_text_28 = "M1";
   if (TF2 == PERIOD_M5) l_text_28 = "M5";
   if (TF2 == PERIOD_M15) l_text_28 = "M15";
   if (TF2 == PERIOD_M30) l_text_28 = "M30";
   if (TF2 == PERIOD_H1) l_text_28 = "H1";
   if (TF2 == PERIOD_H4) l_text_28 = "H4";
   if (TF2 == PERIOD_D1) l_text_28 = "D1";
   if (TF2 == PERIOD_W1) l_text_28 = "W1";
   if (TF2 == PERIOD_MN1) l_text_28 = "MN";
   if (TF3 == PERIOD_M1) l_text_36 = "M1";
   if (TF3 == PERIOD_M5) l_text_36 = "M5";
   if (TF3 == PERIOD_M15) l_text_36 = "M15";
   if (TF3 == PERIOD_M30) l_text_36 = "M30";
   if (TF3 == PERIOD_H1) l_text_36 = "H1";
   if (TF3 == PERIOD_H4) l_text_36 = "H4";
   if (TF3 == PERIOD_D1) l_text_36 = "D1";
   if (TF3 == PERIOD_W1) l_text_36 = "W1";
   if (TF3 == PERIOD_MN1) l_text_36 = "MN";
   if (TF4 == PERIOD_M1) l_text_44 = "M1";
   if (TF4 == PERIOD_M5) l_text_44 = "M5";
   if (TF4 == PERIOD_M15) l_text_44 = "M15";
   if (TF4 == PERIOD_M30) l_text_44 = "M30";
   if (TF4 == PERIOD_H1) l_text_44 = "H1";
   if (TF4 == PERIOD_H4) l_text_44 = "H4";
   if (TF4 == PERIOD_D1) l_text_44 = "D1";
   if (TF4 == PERIOD_W1) l_text_44 = "W1";
   if (TF4 == PERIOD_MN1) l_text_44 = "MN";
   if (TF5 == PERIOD_M1) l_text_52 = "M1";
   if (TF5 == PERIOD_M5) l_text_52 = "M5";
   if (TF5 == PERIOD_M15) l_text_52 = "M15";
   if (TF5 == PERIOD_M30) l_text_52 = "M30";
   if (TF5 == PERIOD_H1) l_text_52 = "H1";
   if (TF5 == PERIOD_H4) l_text_52 = "H4";
   if (TF5 == PERIOD_D1) l_text_52 = "D1";
   if (TF5 == PERIOD_W1) l_text_52 = "W1";
   if (TF5 == PERIOD_MN1) l_text_52 = "MN";
   if (TF6 == PERIOD_M1) l_text_60 = "M1";
   if (TF6 == PERIOD_M5) l_text_60 = "M5";
   if (TF6 == PERIOD_M15) l_text_60 = "M15";
   if (TF6 == PERIOD_M30) l_text_60 = "M30";
   if (TF6 == PERIOD_H1) l_text_60 = "H1";
   if (TF6 == PERIOD_H4) l_text_60 = "H4";
   if (TF6 == PERIOD_D1) l_text_60 = "D1";
   if (TF6 == PERIOD_W1) l_text_60 = "W1";
   if (TF6 == PERIOD_MN1) l_text_60 = "MN";
   if (TF7 == PERIOD_M1) l_text_68 = "M1";
   if (TF7 == PERIOD_M5) l_text_68 = "M5";
   if (TF7 == PERIOD_M15) l_text_68 = "M15";
   if (TF7 == PERIOD_M30) l_text_68 = "M30";
   if (TF7 == PERIOD_H1) l_text_68 = "H1";
   if (TF7 == PERIOD_H4) l_text_68 = "H4";
   if (TF7 == PERIOD_D1) l_text_68 = "D1";
   if (TF7 == PERIOD_W1) l_text_68 = "W1";
   if (TF7 == PERIOD_MN1) l_text_68 = "MN";
   if (TF1 == PERIOD_M15) li_76 = -2;
   if (TF1 == PERIOD_M30) li_76 = -3;
   if (TF2 == PERIOD_M15) li_80 = -2;
   if (TF2 == PERIOD_M30) li_80 = -3;
   if (TF3 == PERIOD_M15) li_84 = -2;
   if (TF3 == PERIOD_M30) li_84 = -3;
   if (TF4 == PERIOD_M15) li_88 = -2;
   if (TF4 == PERIOD_M30) li_88 = -3;
   if (TF5 == PERIOD_M15) li_92 = -2;
   if (TF5 == PERIOD_M30) li_92 = -3;
   if (TF6 == PERIOD_M15) li_96 = -2;
   if (TF6 == PERIOD_M30) li_96 = -3;
   if (TF7 == PERIOD_M15) li_100 = -2;
   if (TF6 == PERIOD_M30) li_100 = -3;
   if (Shift_UP_DN < 0) return (0);
   Signal("SIG_BARS_TF1", Adjust_Side_to_side + 114 + li_76, Shift_UP_DN + 42);
   ObjectSetText("SIG_BARS_TF1", l_text_20, 7, "Arial Bold", TimeFrame_Label_color);
   Signal("SIG_BARS_TF2", Adjust_Side_to_side + 97 + li_80, Shift_UP_DN + 42);
   ObjectSetText("SIG_BARS_TF2", l_text_28, 7, "Arial Bold", TimeFrame_Label_color);
   Signal("SIG_BARS_TF3", Adjust_Side_to_side + 80 + li_84, Shift_UP_DN + 42);
   ObjectSetText("SIG_BARS_TF3", l_text_36, 7, "Arial Bold", TimeFrame_Label_color);
   Signal("SIG_BARS_TF4", Adjust_Side_to_side + 63 + li_88, Shift_UP_DN + 42);
   ObjectSetText("SIG_BARS_TF4", l_text_44, 7, "Arial Bold", TimeFrame_Label_color);
   Signal("SIG_BARS_TF5", Adjust_Side_to_side + 46 + li_92, Shift_UP_DN + 42);
   ObjectSetText("SIG_BARS_TF5", l_text_52, 7, "Arial Bold", TimeFrame_Label_color);
   Signal("SIG_BARS_TF6", Adjust_Side_to_side + 29 + li_96, Shift_UP_DN + 42);
   ObjectSetText("SIG_BARS_TF6", l_text_60, 7, "Arial Bold", TimeFrame_Label_color);
   Signal("SIG_BARS_TF7", Adjust_Side_to_side + 12 + li_100, Shift_UP_DN + 42);
   ObjectSetText("SIG_BARS_TF7", l_text_68, 7, "Arial Bold", TimeFrame_Label_color);
   string l_text_104 = "";
   string l_text_112 = "";
   string l_text_120 = "";
   string l_text_128 = "";
   string l_text_136 = "";
   string l_text_144 = "";
   string l_text_152 = "";
   string ls_unused_160 = "";
   string ls_unused_168 = "";
   double l_imacd_212 = iMACD(NULL, TF1, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_220 = iMACD(NULL, TF1, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_228 = iMACD(NULL, TF2, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_236 = iMACD(NULL, TF2, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_244 = iMACD(NULL, TF3, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_252 = iMACD(NULL, TF3, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_260 = iMACD(NULL, TF4, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_268 = iMACD(NULL, TF4, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_276 = iMACD(NULL, TF5, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_284 = iMACD(NULL, TF5, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_292 = iMACD(NULL, TF6, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_300 = iMACD(NULL, TF6, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_308 = iMACD(NULL, TF7, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_316 = iMACD(NULL, TF7, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   if (l_imacd_212 > l_imacd_220) {
      l_text_128 = "ggg";
      l_color_188 = XUP_below_0;
   }
   if (l_imacd_212 <= l_imacd_220) {
      l_text_128 = "ggg";
      l_color_188 = XDN_above_0;
   }
   if (l_imacd_212 > l_imacd_220 && l_imacd_212 > 0.0) {
      l_text_128 = "ggg";
      l_color_188 = XUP_above_0;
   }
   if (l_imacd_212 <= l_imacd_220 && l_imacd_212 < 0.0) {
      l_text_128 = "ggg";
      l_color_188 = XDN_below_0;
   }
   if (l_imacd_228 > l_imacd_236) {
      l_text_136 = "ggg";
      l_color_192 = XUP_below_0;
   }
   if (l_imacd_228 <= l_imacd_236) {
      l_text_136 = "ggg";
      l_color_192 = XDN_above_0;
   }
   if (l_imacd_228 > l_imacd_236 && l_imacd_228 > 0.0) {
      l_text_136 = "ggg";
      l_color_192 = XUP_above_0;
   }
   if (l_imacd_228 <= l_imacd_236 && l_imacd_228 < 0.0) {
      l_text_136 = "ggg";
      l_color_192 = XDN_below_0;
   }
   if (l_imacd_244 > l_imacd_252) {
      l_text_144 = "ggg";
      l_color_196 = XUP_below_0;
   }
   if (l_imacd_244 <= l_imacd_252) {
      l_text_144 = "ggg";
      l_color_196 = XDN_above_0;
   }
   if (l_imacd_244 > l_imacd_252 && l_imacd_244 > 0.0) {
      l_text_144 = "ggg";
      l_color_196 = XUP_above_0;
   }
   if (l_imacd_244 <= l_imacd_252 && l_imacd_244 < 0.0) {
      l_text_144 = "ggg";
      l_color_196 = XDN_below_0;
   }
   if (l_imacd_260 > l_imacd_268) {
      l_text_152 = "ggg";
      l_color_200 = XUP_below_0;
   }
   if (l_imacd_260 <= l_imacd_268) {
      l_text_152 = "ggg";
      l_color_200 = XDN_above_0;
   }
   if (l_imacd_260 > l_imacd_268 && l_imacd_260 > 0.0) {
      l_text_152 = "ggg";
      l_color_200 = XUP_above_0;
   }
   if (l_imacd_260 <= l_imacd_268 && l_imacd_260 < 0.0) {
      l_text_152 = "ggg";
      l_color_200 = XDN_below_0;
   }
   if (l_imacd_276 > l_imacd_284) {
      l_text_112 = "ggg";
      l_color_180 = XUP_below_0;
   }
   if (l_imacd_276 <= l_imacd_284) {
      l_text_112 = "ggg";
      l_color_180 = XDN_above_0;
   }
   if (l_imacd_276 > l_imacd_284 && l_imacd_276 > 0.0) {
      l_text_112 = "ggg";
      l_color_180 = XUP_above_0;
   }
   if (l_imacd_276 <= l_imacd_284 && l_imacd_276 < 0.0) {
      l_text_112 = "ggg";
      l_color_180 = XDN_below_0;
   }
   if (l_imacd_292 > l_imacd_300) {
      l_text_120 = "ggg";
      l_color_184 = XUP_below_0;
   }
   if (l_imacd_292 <= l_imacd_300) {
      l_text_120 = "ggg";
      l_color_184 = XDN_above_0;
   }
   if (l_imacd_292 > l_imacd_300 && l_imacd_292 > 0.0) {
      l_text_120 = "ggg";
      l_color_184 = XUP_above_0;
   }
   if (l_imacd_292 <= l_imacd_300 && l_imacd_292 < 0.0) {
      l_text_120 = "ggg";
      l_color_184 = XDN_below_0;
   }
   if (l_imacd_308 > l_imacd_316) {
      l_text_104 = "ggg";
      l_color_176 = XUP_below_0;
   }
   if (l_imacd_308 <= l_imacd_316) {
      l_text_104 = "ggg";
      l_color_176 = XDN_above_0;
   }
   if (l_imacd_308 > l_imacd_316 && l_imacd_308 > 0.0) {
      l_text_104 = "ggg";
      l_color_176 = XUP_above_0;
   }
   if (l_imacd_308 <= l_imacd_316 && l_imacd_308 < 0.0) {
      l_text_104 = "ggg";
      l_color_176 = XDN_below_0;
   }
 //  Signal("SSignalMACD_TEXT", Adjust_Side_to_side + 153, Shift_UP_DN + 33);
 //  ObjectSetText("SSignalMACD_TEXT", "MACD", 6, "Arial Bold", BarLabel_color);
   Signal("SSignalMACDM1", Adjust_Side_to_side + 112, Shift_UP_DN + 55);
   ObjectSetText("SSignalMACDM1", l_text_128, 2, "Webdings", l_color_188);
   Signal("SSignalMACDM5", Adjust_Side_to_side + 95, Shift_UP_DN + 55);
   ObjectSetText("SSignalMACDM5", l_text_136, 2, "Webdings", l_color_192);
   Signal("SSignalMACDM15", Adjust_Side_to_side + 78, Shift_UP_DN + 55);
   ObjectSetText("SSignalMACDM15", l_text_144, 2, "Webdings", l_color_196);
   Signal("SSignalMACDM30", Adjust_Side_to_side + 61, Shift_UP_DN + 55);
   ObjectSetText("SSignalMACDM30", l_text_152, 2, "Webdings", l_color_200);
   Signal("SSignalMACDH1", Adjust_Side_to_side + 44, Shift_UP_DN + 55);
   ObjectSetText("SSignalMACDH1", l_text_112, 2, "Webdings", l_color_180);
   Signal("SSignalMACDH4", Adjust_Side_to_side + 27, Shift_UP_DN + 55);
   ObjectSetText("SSignalMACDH4", l_text_120, 2, "Webdings", l_color_184);
   Signal("SSignalMACDD1", Adjust_Side_to_side + 10, Shift_UP_DN + 55);
   ObjectSetText("SSignalMACDD1", l_text_104, 2, "Webdings", l_color_176);
   
   
   
   
/*   double l_irsi_324 = iRSI(NULL, TF7, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_332 = iRSI(NULL, TF6, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_340 = iRSI(NULL, TF5, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_348 = iRSI(NULL, TF4, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_356 = iRSI(NULL, TF3, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_364 = iRSI(NULL, TF2, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_372 = iRSI(NULL, TF1, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_istochastic_380 = iStochastic(NULL, TF7, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_388 = iStochastic(NULL, TF6, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_396 = iStochastic(NULL, TF5, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_404 = iStochastic(NULL, TF4, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_412 = iStochastic(NULL, TF3, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_420 = iStochastic(NULL, TF2, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_428 = iStochastic(NULL, TF1, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_icci_436 = iCCI(NULL, TF7, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_444 = iCCI(NULL, TF6, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_452 = iCCI(NULL, TF5, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_460 = iCCI(NULL, TF4, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_468 = iCCI(NULL, TF3, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_476 = iCCI(NULL, TF2, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_484 = iCCI(NULL, TF1, CCI_Period, CCI_PRICE_TYPE, 0);
   string l_text_492 = "";
   string l_text_500 = "";
   string l_text_508 = "";
   string l_text_516 = "";
   string l_text_524 = "";
   string l_text_532 = "";
   string l_text_540 = "";
   string ls_unused_548 = "";
   string ls_unused_556 = "";
   l_text_540 = "ggg";
   color l_color_592 = STR_NO_Signal;
   l_text_524 = "ggg";
   color l_color_588 = STR_NO_Signal;
   l_text_492 = "ggg";
   color l_color_584 = STR_NO_Signal;
   l_text_532 = "ggg";
   color l_color_580 = STR_NO_Signal;
   l_text_500 = "ggg";
   color l_color_576 = STR_NO_Signal;
   l_text_508 = "ggg";
   color l_color_572 = STR_NO_Signal;
   l_text_516 = "ggg";
   color l_color_568 = STR_NO_Signal;
   if (l_irsi_324 > 50.0 && l_istochastic_380 > 40.0 && l_icci_436 > 0.0) {
      l_text_540 = "ggg";
      l_color_592 = STR_UP;
   }
   if (l_irsi_332 > 50.0 && l_istochastic_388 > 40.0 && l_icci_444 > 0.0) {
      l_text_524 = "ggg";
      l_color_588 = STR_UP;
   }
   if (l_irsi_340 > 50.0 && l_istochastic_396 > 40.0 && l_icci_452 > 0.0) {
      l_text_492 = "ggg";
      l_color_584 = STR_UP;
   }
   if (l_irsi_348 > 50.0 && l_istochastic_404 > 40.0 && l_icci_460 > 0.0) {
      l_text_532 = "ggg";
      l_color_580 = STR_UP;
   }
   if (l_irsi_356 > 50.0 && l_istochastic_412 > 40.0 && l_icci_468 > 0.0) {
      l_text_500 = "ggg";
      l_color_576 = STR_UP;
   }
   if (l_irsi_364 > 50.0 && l_istochastic_420 > 40.0 && l_icci_476 > 0.0) {
      l_text_508 = "ggg";
      l_color_572 = STR_UP;
   }
   if (l_irsi_372 > 50.0 && l_istochastic_428 > 40.0 && l_icci_484 > 0.0) {
      l_text_516 = "ggg";
      l_color_568 = STR_UP;
   }
   if (l_irsi_324 < 50.0 && l_istochastic_380 < 60.0 && l_icci_436 < 0.0) {
      l_text_540 = "ggg";
      l_color_592 = STR_DN;
   }
   if (l_irsi_332 < 50.0 && l_istochastic_388 < 60.0 && l_icci_444 < 0.0) {
      l_text_524 = "ggg";
      l_color_588 = STR_DN;
   }
   if (l_irsi_340 < 50.0 && l_istochastic_396 < 60.0 && l_icci_452 < 0.0) {
      l_text_492 = "ggg";
      l_color_584 = STR_DN;
   }
   if (l_irsi_348 < 50.0 && l_istochastic_404 < 60.0 && l_icci_460 < 0.0) {
      l_text_532 = "ggg";
      l_color_580 = STR_DN;
   }
   if (l_irsi_356 < 50.0 && l_istochastic_412 < 60.0 && l_icci_468 < 0.0) {
      l_text_500 = "ggg";
      l_color_576 = STR_DN;
   }
   if (l_irsi_364 < 50.0 && l_istochastic_420 < 60.0 && l_icci_476 < 0.0) {
      l_text_508 = "ggg";
      l_color_572 = STR_DN;
   }
   if (l_irsi_372 < 50.0 && l_istochastic_428 < 60.0 && l_icci_484 < 0.0) {
      l_text_516 = "ggg";
      l_color_568 = STR_DN;
   }
   Signal("SSignalSTR_TEXT", Adjust_Side_to_side + 153, Shift_UP_DN + 42);
   ObjectSetText("SSignalSTR_TEXT", "STR", 6, "Arial Bold", BarLabel_color);
   Signal("SignalSTRM1", Adjust_Side_to_side + 130, Shift_UP_DN + 44);
   ObjectSetText("SignalSTRM1", l_text_516, 5, "Webdings", l_color_568);
   Signal("SignalSTRM5", Adjust_Side_to_side + 110, Shift_UP_DN + 44);
   ObjectSetText("SignalSTRM5", l_text_508, 5, "Webdings", l_color_572);
   Signal("SignalSTRM15", Adjust_Side_to_side + 90, Shift_UP_DN + 44);
   ObjectSetText("SignalSTRM15", l_text_500, 5, "Webdings", l_color_576);
   Signal("SignalSTRM30", Adjust_Side_to_side + 70, Shift_UP_DN + 44);
   ObjectSetText("SignalSTRM30", l_text_532, 5, "Webdings", l_color_580);
   Signal("SignalSTRH1", Adjust_Side_to_side + 50, Shift_UP_DN + 44);
   ObjectSetText("SignalSTRH1", l_text_492, 5, "Webdings", l_color_584);
   Signal("SignalSTRH4", Adjust_Side_to_side + 30, Shift_UP_DN + 44);
   ObjectSetText("SignalSTRH4", l_text_524, 5, "Webdings", l_color_588);
   Signal("SignalSTRD1", Adjust_Side_to_side + 10, Shift_UP_DN + 44);
   ObjectSetText("SignalSTRD1", l_text_540, 5, "Webdings", l_color_592);*/
   
   double l_ima_604 = iMA(Symbol(), TF1, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_612 = iMA(Symbol(), TF1, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_620 = iMA(Symbol(), TF2, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_628 = iMA(Symbol(), TF2, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_636 = iMA(Symbol(), TF3, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_644 = iMA(Symbol(), TF3, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_652 = iMA(Symbol(), TF4, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_660 = iMA(Symbol(), TF4, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_668 = iMA(Symbol(), TF5, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_676 = iMA(Symbol(), TF5, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_684 = iMA(Symbol(), TF6, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_692 = iMA(Symbol(), TF6, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_700 = iMA(Symbol(), TF7, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_708 = iMA(Symbol(), TF7, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   string l_text_716 = "";
   string l_text_724 = "";
   string l_text_732 = "";
   string l_text_740 = "";
   string l_text_748 = "";
   string l_text_756 = "";
   string l_text_764 = "";
   string ls_unused_772 = "";
   string ls_unused_780 = "";
   if (l_ima_604 > l_ima_612) {
      l_text_716 = "ggg";
      l_color_796 = MA_UP;
   }
   if (l_ima_604 <= l_ima_612) {
      l_text_716 = "ggg";
      l_color_796 = MA_DN;
   }
   if (l_ima_620 > l_ima_628) {
      l_text_724 = "ggg";
      l_color_800 = MA_UP;
   }
   if (l_ima_620 <= l_ima_628) {
      l_text_724 = "ggg";
      l_color_800 = MA_DN;
   }
   if (l_ima_636 > l_ima_644) {
      l_text_732 = "ggg";
      l_color_804 = MA_UP;
   }
   if (l_ima_636 <= l_ima_644) {
      l_text_732 = "ggg";
      l_color_804 = MA_DN;
   }
   if (l_ima_652 > l_ima_660) {
      l_text_740 = "ggg";
      l_color_808 = MA_UP;
   }
   if (l_ima_652 <= l_ima_660) {
      l_text_740 = "ggg";
      l_color_808 = MA_DN;
   }
   if (l_ima_668 > l_ima_676) {
      l_text_748 = "ggg";
      l_color_812 = MA_UP;
   }
   if (l_ima_668 <= l_ima_676) {
      l_text_748 = "ggg";
      l_color_812 = MA_DN;
   }
   if (l_ima_684 > l_ima_692) {
      l_text_756 = "ggg";
      l_color_816 = MA_UP;
   }
   if (l_ima_684 <= l_ima_692) {
      l_text_756 = "ggg";
      l_color_816 = MA_DN;
   }
   if (l_ima_700 > l_ima_708) {
      l_text_764 = "ggg";
      l_color_820 = MA_UP;
   }
   if (l_ima_700 <= l_ima_708) {
      l_text_764 = "ggg";
      l_color_820 = MA_DN;
   }
  // Signal("SignalEMA_TEXT", Adjust_Side_to_side + 153, Shift_UP_DN + 33);//51
  // ObjectSetText("SignalEMA_TEXT", "EMA", 6, "Arial Bold", BarLabel_color);
   Signal("SignalEMAM1", Adjust_Side_to_side + 112, Shift_UP_DN + 35);//53
   ObjectSetText("SignalEMAM1", l_text_716, 2, "Webdings", l_color_796);
   Signal("SignalEMAM5", Adjust_Side_to_side + 95, Shift_UP_DN + 35);
   ObjectSetText("SignalEMAM5", l_text_724, 2, "Webdings", l_color_800);
   Signal("SignalEMAM15", Adjust_Side_to_side + 78, Shift_UP_DN + 35);
   ObjectSetText("SignalEMAM15", l_text_732, 2, "Webdings", l_color_804);
   Signal("SignalEMAM30", Adjust_Side_to_side + 61, Shift_UP_DN + 35);
   ObjectSetText("SignalEMAM30", l_text_740, 2, "Webdings", l_color_808);
   Signal("SignalEMAH1", Adjust_Side_to_side + 44, Shift_UP_DN + 35);
   ObjectSetText("SignalEMAH1", l_text_748, 2, "Webdings", l_color_812);
   Signal("SignalEMAH4", Adjust_Side_to_side + 27, Shift_UP_DN + 35);
   ObjectSetText("SignalEMAH4", l_text_756, 2, "Webdings", l_color_816);
   Signal("SignalEMAD1", Adjust_Side_to_side + 10, Shift_UP_DN + 35);
   ObjectSetText("SignalEMAD1", l_text_764, 2, "Webdings", l_color_820);
   double ld_832 = NormalizeDouble(MarketInfo(Symbol(), MODE_BID), Digits);
   double l_ima_840 = iMA(Symbol(), PERIOD_M1, 1, 0, MODE_EMA, PRICE_CLOSE, 1);
   string ls_unused_848 = "";
   if (l_ima_840 > ld_832) {
      ls_unused_848 = "";
      l_color_856 = Price_DN;
   }
   if (l_ima_840 < ld_832) {
      ls_unused_848 = "";
      l_color_856 = Price_UP;
   }
   if (l_ima_840 == ld_832) {
      ls_unused_848 = "";
      l_color_856 = Price_Neutral;
   }
//   Signal("cja", Adjust_Side_to_side + 153, Shift_UP_DN + 21);
//   ObjectSetText("cja", "cja", 8, "Arial", DimGray);
   if (Show_Smaller_Size == FALSE) {
      if (Show_Price == TRUE) {
         Signal("Signalprice", Adjust_Side_to_side + 10, Shift_UP_DN + 57);
         ObjectSetText("Signalprice", DoubleToStr(ld_832, Digits), 33, "Arial", l_color_856);
      }
   }
   if (Show_Smaller_Size == TRUE) {
      if (Show_Price == TRUE) {
         Signal("Signalprice", Adjust_Side_to_side + 10, Shift_UP_DN + 60);
         ObjectSetText("Signalprice", DoubleToStr(ld_832, Digits), 15, "Arial", l_color_856);
      }
   }
   int li_860 = 0;
   int li_864 = 0;
   int li_868 = 0;
   int li_872 = 0;
   int li_876 = 0;
   int li_880 = 0;
   li_860 = (iHigh(NULL, PERIOD_D1, 1) - iLow(NULL, PERIOD_D1, 1)) / Point;
   for (li_880 = 1; li_880 <= 5; li_880++) li_864 = li_864 + (iHigh(NULL, PERIOD_D1, li_880) - iLow(NULL, PERIOD_D1, li_880)) / Point;
   for (li_880 = 1; li_880 <= 10; li_880++) li_868 = li_868 + (iHigh(NULL, PERIOD_D1, li_880) - iLow(NULL, PERIOD_D1, li_880)) / Point;
   for (li_880 = 1; li_880 <= 20; li_880++) li_872 = li_872 + (iHigh(NULL, PERIOD_D1, li_880) - iLow(NULL, PERIOD_D1, li_880)) / Point;
   li_864 /= 5;
   li_868 /= 10;
   li_872 /= 20;
   li_876 = (li_860 + li_864 + li_868 + li_872) / 4;
   string ls_unused_884 = "";
   string ls_unused_892 = "";
   string l_dbl2str_900 = "";
   string l_dbl2str_908 = "";
   string l_dbl2str_916 = "";
   string l_dbl2str_924 = "";
   string ls_unused_940 = "";
   string ls_unused_948 = "";
   string ls_956 = "";
   if (Digit_Switch == 5) {
      l_iopen_972 = iOpen(NULL, PERIOD_D1, 0);
      l_iclose_980 = iClose(NULL, PERIOD_D1, 0);
      ld_988 = (Ask - Bid) / Point;
      l_ihigh_996 = iHigh(NULL, PERIOD_D1, 0);
      l_ilow_1004 = iLow(NULL, PERIOD_D1, 0);
      l_dbl2str_908 = DoubleToStr((l_iclose_980 - l_iopen_972) / Point, 0);
      l_dbl2str_900 = DoubleToStr(ld_988, Digits - 4);
      l_dbl2str_916 = DoubleToStr(li_876, Digits - 5);
      ls_956 = (iHigh(NULL, PERIOD_D1, 1) - iLow(NULL, PERIOD_D1, 1)) / Point;
      l_dbl2str_924 = DoubleToStr((l_ihigh_996 - l_ilow_1004) / Point, 0);
   }
   if (Digit_Switch == 6) {
      l_iopen_972 = iOpen(NULL, PERIOD_D1, 0);
      l_iclose_980 = iClose(NULL, PERIOD_D1, 0);
      ld_988 = (Ask - Bid) / Point;
      l_ihigh_996 = iHigh(NULL, PERIOD_D1, 0);
      l_ilow_1004 = iLow(NULL, PERIOD_D1, 0);
      l_dbl2str_908 = DoubleToStr((l_iclose_980 - l_iopen_972) / 10.0 / Point, 0);
      l_dbl2str_900 = DoubleToStr(ld_988 / 10.0, Digits - 4);
      l_dbl2str_916 = DoubleToStr(li_876 / 10, Digits - 5);
      ls_956 = (iHigh(NULL, PERIOD_D1, 1) - iLow(NULL, PERIOD_D1, 1)) / 10.0 / Point;
      l_dbl2str_924 = DoubleToStr((l_ihigh_996 - l_ilow_1004) / 10.0 / Point, 0);
   }
   if (l_iclose_980 >= l_iopen_972) {
      ls_unused_940 = "-";
      l_color_964 = Pips_UP;
   }
   if (l_iclose_980 < l_iopen_972) {
      ls_unused_940 = "-";
      l_color_964 = Pips_DN;
   }
   if (l_dbl2str_916 >= ls_956) {
      ls_unused_948 = "-";
      l_color_968 = Daily_AV_UP;
   }
   if (l_dbl2str_916 < ls_956) {
      ls_unused_948 = "-";
      l_color_968 = Daily_AV_DN;
   }
   if (Show_Smaller_Size == FALSE) {
      if (Show_Xtra_Details == TRUE) {
         if (Show_Price == TRUE) {
            Signal("SIG_DETAIL_1", Adjust_Side_to_side + 45, Shift_UP_DN + 100);
            ObjectSetText("SIG_DETAIL_1", "Spread", 12, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_2", Adjust_Side_to_side + 10, Shift_UP_DN + 100);
            ObjectSetText("SIG_DETAIL_2", "" + l_dbl2str_900 + "", 12, "Arial Bold", Spread_color);
            Signal("SIG_DETAIL_3", Adjust_Side_to_side + 45, Shift_UP_DN + 115);
            ObjectSetText("SIG_DETAIL_3", "Pips to Open", 12, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_4", Adjust_Side_to_side + 10, Shift_UP_DN + 115);
            ObjectSetText("SIG_DETAIL_4", "" + l_dbl2str_908 + "", 12, "Arial Bold", l_color_964);
            Signal("SIG_DETAIL_5", Adjust_Side_to_side + 45, Shift_UP_DN + 130);
            ObjectSetText("SIG_DETAIL_5", "Hi to Low", 12, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_6", Adjust_Side_to_side + 10, Shift_UP_DN + 130);
            ObjectSetText("SIG_DETAIL_6", "" + l_dbl2str_924 + "", 12, "Arial Bold", HI_LO_color);
            Signal("SIG_DETAIL_7", Adjust_Side_to_side + 45, Shift_UP_DN + 145);
            ObjectSetText("SIG_DETAIL_7", "Daily Av", 12, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_8", Adjust_Side_to_side + 10, Shift_UP_DN + 145);
            ObjectSetText("SIG_DETAIL_8", "" + l_dbl2str_916 + "", 12, "Arial Bold", l_color_968);
         }
      }
   }
   if (Show_Smaller_Size == FALSE) {
      if (Show_Xtra_Details == TRUE) {
         if (Show_Price == FALSE) {
            Signal("SIG_DETAIL_1", Adjust_Side_to_side + 45, Shift_UP_DN + 60);
            ObjectSetText("SIG_DETAIL_1", "Spread", 12, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_2", Adjust_Side_to_side + 10, Shift_UP_DN + 60);
            ObjectSetText("SIG_DETAIL_2", "" + l_dbl2str_900 + "", 12, "Arial Bold", Spread_color);
            Signal("SIG_DETAIL_3", Adjust_Side_to_side + 45, Shift_UP_DN + 75);
            ObjectSetText("SIG_DETAIL_3", "Pips to Open", 12, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_4", Adjust_Side_to_side + 10, Shift_UP_DN + 75);
            ObjectSetText("SIG_DETAIL_4", "" + l_dbl2str_908 + "", 12, "Arial Bold", l_color_964);
            Signal("SIG_DETAIL_5", Adjust_Side_to_side + 45, Shift_UP_DN + 90);
            ObjectSetText("SIG_DETAIL_5", "Hi to Low", 12, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_6", Adjust_Side_to_side + 10, Shift_UP_DN + 90);
            ObjectSetText("SIG_DETAIL_6", "" + l_dbl2str_924 + "", 12, "Arial Bold", HI_LO_color);
            Signal("SIG_DETAIL_7", Adjust_Side_to_side + 45, Shift_UP_DN + 105);
            ObjectSetText("SIG_DETAIL_7", "Daily Av", 12, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_8", Adjust_Side_to_side + 10, Shift_UP_DN + 105);
            ObjectSetText("SIG_DETAIL_8", "" + l_dbl2str_916 + "", 12, "Arial Bold", l_color_968);
         }
      }
   }
   if (Show_Smaller_Size == TRUE) {
      if (Show_Xtra_Details == TRUE) {
         if (Show_Price == TRUE) {
            Signal("SIG_DETAIL_1", Adjust_Side_to_side + 40, Shift_UP_DN + 80);
            ObjectSetText("SIG_DETAIL_1", "Spread", 10, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_2", Adjust_Side_to_side + 10, Shift_UP_DN + 80);
            ObjectSetText("SIG_DETAIL_2", "" + l_dbl2str_900 + "", 9, "Arial Bold", Spread_color);
            Signal("SIG_DETAIL_3", Adjust_Side_to_side + 40, Shift_UP_DN + 95);
            ObjectSetText("SIG_DETAIL_3", "Pips to Open", 10, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_4", Adjust_Side_to_side + 10, Shift_UP_DN + 95);
            ObjectSetText("SIG_DETAIL_4", "" + l_dbl2str_908 + "", 9, "Arial Bold", l_color_964);
            Signal("SIG_DETAIL_5", Adjust_Side_to_side + 40, Shift_UP_DN + 110);
            ObjectSetText("SIG_DETAIL_5", "Hi to Low", 10, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_6", Adjust_Side_to_side + 10, Shift_UP_DN + 110);
            ObjectSetText("SIG_DETAIL_6", "" + l_dbl2str_924 + "", 9, "Arial Bold", HI_LO_color);
            Signal("SIG_DETAIL_7", Adjust_Side_to_side + 40, Shift_UP_DN + 125);
            ObjectSetText("SIG_DETAIL_7", "Daily Av", 10, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_8", Adjust_Side_to_side + 10, Shift_UP_DN + 125);
            ObjectSetText("SIG_DETAIL_8", "" + l_dbl2str_916 + "", 9, "Arial Bold", l_color_968);
         }
      }
   }
   if (Show_Smaller_Size == TRUE) {
      if (Show_Xtra_Details == TRUE) {
         if (Show_Price == FALSE) {
            Signal("SIG_DETAIL_1", Adjust_Side_to_side + 40, Shift_UP_DN + 60);
            ObjectSetText("SIG_DETAIL_1", "Spread", 10, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_2", Adjust_Side_to_side + 10, Shift_UP_DN + 60);
            ObjectSetText("SIG_DETAIL_2", "" + l_dbl2str_900 + "", 9, "Arial Bold", Spread_color);
            Signal("SIG_DETAIL_3", Adjust_Side_to_side + 40, Shift_UP_DN + 75);
            ObjectSetText("SIG_DETAIL_3", "Pips to Open", 10, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_4", Adjust_Side_to_side + 10, Shift_UP_DN + 75);
            ObjectSetText("SIG_DETAIL_4", "" + l_dbl2str_908 + "", 9, "Arial Bold", l_color_964);
            Signal("SIG_DETAIL_5", Adjust_Side_to_side + 40, Shift_UP_DN + 90);
            ObjectSetText("SIG_DETAIL_5", "Hi to Low", 10, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_6", Adjust_Side_to_side + 10, Shift_UP_DN + 90);
            ObjectSetText("SIG_DETAIL_6", "" + l_dbl2str_924 + "", 9, "Arial Bold", HI_LO_color);
            Signal("SIG_DETAIL_7", Adjust_Side_to_side + 40, Shift_UP_DN + 105);
            ObjectSetText("SIG_DETAIL_7", "Daily Av", 10, "Arial", CommentLabel_color);
            Signal("SIG_DETAIL_8", Adjust_Side_to_side + 10, Shift_UP_DN + 105);
            ObjectSetText("SIG_DETAIL_8", "" + l_dbl2str_916 + "", 9, "Arial Bold", l_color_968);
         }
      }
   }
   return (0);
   }
// ------------------------------------------------------------------------------------------ //
//                                     E N D   P R O G R A M                                  //
// ------------------------------------------------------------------------------------------ //
/*                                                         
                                        ud$$$**BILLION$bc.                          
                                    u@**"        PROJECT$$Nu                       
                                  J                ""#$$$$$$r                     
                                 @                       $$$$b                    
                               .F                        ^*3$$$                   
                              :% 4                         J$$$N                  
                              $  :F                       :$$$$$                  
                             4F  9                       J$$$$$$$                 
                             4$   k             4$$$$bed$$$$$$$$$                 
                             $$r  'F            $$$$$$$$$$$$$$$$$r                
                             $$$   b.           $$$$$$$$$$$$$$$$$N                
                             $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
              .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
              :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
             @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
             $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
             $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
              ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
                 ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
                      ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
                        ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                          '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                             #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                               "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                                 "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                                   ?k         ?$$$$$$$$$$$F'*                     
                                    9$$bL     z$$$$$$$$$$$F                       
                                     $$$$    $$$$$$$$$$$$$                        
                                      '#$$c  '$$$$$$$$$"                          
                                       .@"#$$$$$$$$$$$$b                          
                                     z*      $$$$$$$$$$$$N.                       
                                   e"      z$$"  #$$$k  '*$$.                     
                                .u*      u@$P"      '#$$c   "$$c                   
                        u@$*"""       d$$"            "$$$u  ^*$$b.               
                      :$F           J$P"                ^$$$c   '"$$$$$$bL        
                     d$$  ..      @$#                      #$$b         '#$       
                     9$$$$$$b   4$$                          ^$$k         '$      
                      "$$6""$b u$$                             '$    d$$$$$P      
                        '$F $$$$$"                              ^b  ^$$$$b$       
                         '$W$$$$"                                'b@$$$$"         
                                                                  ^$$$*/     