
// +----------------------------------------------------------------------------------------+ //
// |    .-._______                           XARD777                          _______.-.    | //
// |---( )_)______)                 Knowledge of the ancients                (______(_( )---| //
// |  (    ()___)                              \/                             (___()    )  | //
// |       ()__)                              (o o)                             (__()       | //
// |--(___()_)__________________________oOOo___(_)___oOOo_________________________(_()___)--| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                   2011 | //
// |----------------------------------------------------------------------------------------| //
// |                 File:     !BDP OANFX1.mq4                                              | //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 229 (current version)                              | //
// |                                                               [BILLION DOLLAR PROJECT] | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Magenta
#property indicator_style1 2
#property indicator_color2 Magenta
#property indicator_width2 2
#property indicator_color3 Magenta
#property indicator_width3 2 

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //



// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

int gi_80 = 180;
int gi_84 = 1;
int g_count_76 = 0;
int gi_88 = 0;
double gd_92 = 2.0;
int gi_100 = 1102;
int gi_104 = 0;
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double gda_120[10][10];
double gda_124[10];
double gda_128[10];
double gda_132[20];
double gd_136;
int g_shift_144;
int g_period_148;
int gi_152;
double gd_156;
double gd_164;
double gd_172;
int gi_180;
int gi_184;
int gi_188;
int gi_192;
int gi_196;
double gd_200;
double gd_208;

// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init() {
   IndicatorShortName("Center of Gravity");
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, g_ibuf_108);
   SetIndexBuffer(1, g_ibuf_112);
   SetIndexBuffer(2, g_ibuf_116);
   g_period_148 = MathRound(gi_80);
   gi_196 = gi_84 + 1;
   ObjectCreate("pr" + gi_100, OBJ_ARROW, 0, Time[g_period_148], g_ibuf_108[g_period_148]);
   ObjectSet("pr" + gi_100, OBJPROP_ARROWCODE, 159);
   return (0);
}

// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

int deinit() {
   ObjectDelete("pr" + gi_100);
   return (0);
}

// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

int start() {
   double ld_0;
   double ld_8;
   double l_bid_16;
   g_shift_144 = iBarShift(Symbol(), Period(), ObjectGet("pr" + gi_100, OBJPROP_TIME1));
   g_period_148 = gi_80;
   gda_132[1] = g_period_148 + 1;
   SetIndexDrawBegin(0, Bars - g_period_148 - 1);
   SetIndexDrawBegin(1, Bars - g_period_148 - 1);
   SetIndexDrawBegin(2, Bars - g_period_148 - 1);
   for (int li_24 = 1; li_24 <= gi_196 * 2 - 2; li_24++) {
      gd_136 = 0;
      for (gi_152 = gi_88; gi_152 <= gi_88 + g_period_148; gi_152++) gd_136 += MathPow(gi_152, li_24);
      gda_132[li_24 + 1] = gd_136;
   }
   for (li_24 = 1; li_24 <= gi_196; li_24++) {
      gd_136 = 0.0;
      for (gi_152 = gi_88; gi_152 <= gi_88 + g_period_148; gi_152++) {
         if (li_24 == 1) gd_136 += Close[gi_152];
         else gd_136 += Close[gi_152] * MathPow(gi_152, li_24 - 1);
      }
      gda_124[li_24] = gd_136;
   }
   for (gi_184 = 1; gi_184 <= gi_196; gi_184++) {
      for (gi_180 = 1; gi_180 <= gi_196; gi_180++) {
         gi_188 = gi_180 + gi_184 - 1;
         gda_120[gi_180][gi_184] = gda_132[gi_188];
      }
   }
   for (gi_188 = 1; gi_188 <= gi_196 - 1; gi_188++) {
      gi_192 = 0;
      gd_164 = 0;
      for (gi_180 = gi_188; gi_180 <= gi_196; gi_180++) {
         if (MathAbs(gda_120[gi_180][gi_188]) > gd_164) {
            gd_164 = MathAbs(gda_120[gi_180][gi_188]);
            gi_192 = gi_180;
         }
      }
      if (gi_192 == 0) return (0);
      if (gi_192 != gi_188) {
         for (gi_184 = 1; gi_184 <= gi_196; gi_184++) {
            gd_172 = gda_120[gi_188][gi_184];
            gda_120[gi_188][gi_184] = gda_120[gi_192][gi_184];
            gda_120[gi_192][gi_184] = gd_172;
         }
         gd_172 = gda_124[gi_188];
         gda_124[gi_188] = gda_124[gi_192];
         gda_124[gi_192] = gd_172;
      }
      for (gi_180 = gi_188 + 1; gi_180 <= gi_196; gi_180++) {
         gd_156 = gda_120[gi_180][gi_188] / gda_120[gi_188][gi_188];
         for (gi_184 = 1; gi_184 <= gi_196; gi_184++) {
            if (gi_184 == gi_188) gda_120[gi_180][gi_184] = 0;
            else gda_120[gi_180][gi_184] = gda_120[gi_180][gi_184] - gd_156 * gda_120[gi_188][gi_184];
         }
         gda_124[gi_180] = gda_124[gi_180] - gd_156 * gda_124[gi_188];
      }
   }
   gda_128[gi_196] = gda_124[gi_196] / gda_120[gi_196][gi_196];
   for (gi_180 = gi_196 - 1; gi_180 >= 1; gi_180--) {
      gd_172 = 0;
      for (gi_184 = 1; gi_184 <= gi_196 - gi_180; gi_184++) {
         gd_172 += (gda_120[gi_180][gi_180 + gi_184]) * (gda_128[gi_180 + gi_184]);
         gda_128[gi_180] = 1 / gda_120[gi_180][gi_180] * (gda_124[gi_180] - gd_172);
      }
   }
   for (gi_152 = gi_88; gi_152 <= gi_88 + g_period_148; gi_152++) {
      gd_136 = 0;
      for (gi_188 = 1; gi_188 <= gi_84; gi_188++) gd_136 += (gda_128[gi_188 + 1]) * MathPow(gi_152, gi_188);
      g_ibuf_108[gi_152] = gda_128[1] + gd_136;
   }
   gd_200 = 0.0;
   for (gi_152 = gi_88; gi_152 <= gi_88 + g_period_148; gi_152++) gd_200 += MathPow(Close[gi_152] - g_ibuf_108[gi_152], 2);
   gd_200 = MathSqrt(gd_200 / (g_period_148 + 1)) * gd_92;
   gd_208 = iStdDev(NULL, 0, g_period_148, 0, MODE_SMA, PRICE_CLOSE, gi_88) * gd_92;
   for (gi_152 = gi_88; gi_152 <= gi_88 + g_period_148; gi_152++) {
      g_ibuf_112[gi_152] = g_ibuf_108[gi_152] + gd_200;
      g_ibuf_116[gi_152] = g_ibuf_108[gi_152] - gd_200;
      ld_0 = g_ibuf_112[0];
      ld_8 = g_ibuf_116[0];
      l_bid_16 = Bid;
      if (g_count_76 > gi_104 && l_bid_16 > ld_8 && l_bid_16 < ld_0) g_count_76 = 0;
      if (l_bid_16 >= ld_0 && g_count_76 < gi_104) {
         Alert("Price broke through the second COG Resistance Line on ", Symbol());
         g_count_76++;
      }
      if (l_bid_16 <= ld_8 && g_count_76 < gi_104) {
         Alert("Price broke through the second COG Support Line on ", Symbol());
         g_count_76++;
      }
   }
   ObjectMove("pr" + gi_100, 0, Time[g_period_148], g_ibuf_108[g_period_148]);
   return (0);
   }
// ------------------------------------------------------------------------------------------ //
//                                     E N D   P R O G R A M                                  //
// ------------------------------------------------------------------------------------------ //
/*                                                         
                                        ud$$$**BILLION$bc.                          
                                    u@**"        PROJECT$$Nu                       
                                  J                ""#$$$$$$r                     
                                 @                       $$$$b                    
                               .F                        ^*3$$$                   
                              :% 4                         J$$$N                  
                              $  :F                       :$$$$$                  
                             4F  9                       J$$$$$$$                 
                             4$   k             4$$$$bed$$$$$$$$$                 
                             $$r  'F            $$$$$$$$$$$$$$$$$r                
                             $$$   b.           $$$$$$$$$$$$$$$$$N                
                             $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
              .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
              :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
             @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
             $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
             $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
              ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
                 ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
                      ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
                        ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                          '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                             #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                               "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                                 "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                                   ?k         ?$$$$$$$$$$$F'*                     
                                    9$$bL     z$$$$$$$$$$$F                       
                                     $$$$    $$$$$$$$$$$$$                        
                                      '#$$c  '$$$$$$$$$"                          
                                       .@"#$$$$$$$$$$$$b                          
                                     z*      $$$$$$$$$$$$N.                       
                                   e"      z$$"  #$$$k  '*$$.                     
                                .u*      u@$P"      '#$$c   "$$c                   
                        u@$*"""       d$$"            "$$$u  ^*$$b.               
                      :$F           J$P"                ^$$$c   '"$$$$$$bL        
                     d$$  ..      @$#                      #$$b         '#$       
                     9$$$$$$b   4$$                          ^$$k         '$      
                      "$$6""$b u$$                             '$    d$$$$$P      
                        '$F $$$$$"                              ^b  ^$$$$b$       
                         '$W$$$$"                                'b@$$$$"         
                                                                  ^$$$*/     