
// +----------------------------------------------------------------------------------------+ //
// |    .-._______                           XARD777                          _______.-.    | //
// |---( )_)______)                 Knowledge of the ancients                (______(_( )---| //
// |  (    ()___)                              \/                             (___()    )  | //
// |       ()__)                              (o o)                             (__()       | //
// |--(___()_)__________________________oOOo___(_)___oOOo_________________________(_()___)--| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                   2011 | //
// |----------------------------------------------------------------------------------------| //
// |                 File:     !BDP PANEL.mq4                                               | //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 229 (current version)                              | //
// |                                                               [BILLION DOLLAR PROJECT] | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window

color    color1      = LimeGreen;
color    color2      = SlateGray;
color    color3      = White;
color    color4      = DodgerBlue;

color    TextColor2  = C'192,192,192';
color    TextColor3  = C'50,160,50';
color    TextColor4  = SlateGray;
color    BoxColor    = C'13,13,63';
color    BoxColor1   = C'30,20,40';
color    BoxColor2   = C'7,40,80';

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

extern bool   show.panel      = true;
extern string FiboStart       = "02:00";
extern string FiboEnd         = "02:00"; 

// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

int         OpenBar;
double      LastHigh,
            LastLow,
            LastClose;
int         WhatWindow        = 0;
int         WhatWindow1       = 1;
int         WhatCorner0       = 0;
int         WhatCorner1       = 1;
int         WhatCorner2       = 2;
int         WhatCorner3       = 3;
int         Shift.up.down     = 0;
int         Shift.sideway     = 0;
bool        show.timer        =  true;
bool        show.extra.digit  =  false;  
int         BidFontSize       =  30;
string      BidFontType       =  "Arial Bold";
int         FontSize          =  11;
string      FontType          =  "Arial";
string      FontType2         =  "Arial Bold";
double      DecNos;
double      myPoint;
double      fibo;

double      AUTOSELECT;
double      col               =  White;

double      SetPoint() 

   { 
   double mPoint; 
   
   if (Digits < 4) 
   mPoint = 0.01; 
   else 
   mPoint = 0.0001; 
   
   return(mPoint); 
   }

// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

   int init()
   {
   IndicatorShortName("Price-Info");  
    myPoint = SetPoint(); 
    
   return(0);
   }

// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

   int deinit()
   {
   deleteObjects();
   return(0);
   }

// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

   int start()
   {
   
    if(show.extra.digit){int digit=1;int digitshift=-3;int digitshift1=-5;int digitshift2=3;int fontsize=4;int sprd=1;}
    else{ digitshift=0;digitshift1=0;digitshift2=0;fontsize=0;sprd=0;}

    if (StringFind (Symbol(),"JPY", 0) != -1){ DecNos = 2+digit;}
        else { DecNos = 4+digit; }
     
   int    counted_bars=IndicatorCounted();
        
// ------------------------------------------------------------------------------------------ // 

   if(show.panel){
   
   CreateFX1_Labels( "Panel001",6, 6); 
   ObjectSetText("Panel001", "g", 96, "Webdings", BoxColor2);
   
   CreateFX1_Labels( "Panel002",6,132); 
   ObjectSetText("Panel002", "g", 96, "Webdings", BoxColor2);
   
   CreateFX1_Labels( "Panel003",6,260); 
   ObjectSetText("Panel003", "g", 96, "Webdings", BoxColor2);
   
   CreateFX1_Labels( "Panel004",6,388); 
   ObjectSetText("Panel004", "g", 96, "Webdings", BoxColor2);
   
   CreateFX1_Labels( "Panel005",6,496); 
   ObjectSetText("Panel005", "g", 96, "Webdings", BoxColor2);

// ------------------------------------------------------------------------------------------ //  
   
   CreateFX3_Labels( "Panel006",6,6); 
   ObjectSetText("Panel006", "g", 96, "Webdings", BoxColor2);
   
   CreateFX3_Labels( "Panel007",6,134); 
   ObjectSetText("Panel007", "g", 96, "Webdings", BoxColor2);
   
   CreateFX3_Labels( "Panel008",6,262); 
   ObjectSetText("Panel008", "g", 96, "Webdings", BoxColor2);
   
   CreateFX3_Labels( "Panel009",6,380); 
   ObjectSetText("Panel009", "g", 96, "Webdings", BoxColor2);
   
   CreateFX1_Labels( "Panel010",8,0); 
   ObjectSetText("Panel010", "XARD777", 18, "Arial Black", color4);
     
   }//End show.panel
 
// ------------------------------------------------------------------------------------------ // 
      
   CreateFX1_Labels( "Panel011",16,20); 
   ObjectSetText("Panel011", "FOREX", 22, "Arial Black", color1);
      
// ------------------------------------------------------------------------------------------ //      

   double spread = (Ask-Bid)/myPoint;
   
   if(spread>1 && spread<=10)
   
   int sprdshift=4;
   
   CreateFX3_Labels( "Panel012",10,9); 
   ObjectSetText("Panel012", "ggggg", 18, "Webdings", Black);
   
   CreateFX3_Labels( "Panel013",18,14); 
   ObjectSetText("Panel013", "Spread: "+DoubleToStr(spread,1)+" pips", FontSize, "Arial", color3);

// ------------------------------------------------------------------------------------------ //     

   string symbol="";
   
        if (Symbol()=="EURUSD" || Symbol()=="EURUSDm") {symbol="EURUSD";}
   else if (Symbol()=="GBPUSD" || Symbol()=="GBPUSDm") {symbol="GBPUSD";}
   else if (Symbol()=="USDCHF" || Symbol()=="USDCHFm") {symbol="USDCHF";}
   else if (Symbol()=="USDJPY" || Symbol()=="USDJPYm") {symbol="USDJPY";}
   else if (Symbol()=="EURJPY" || Symbol()=="EURJPYm") {symbol="EURJPY";}
   else if (Symbol()=="EURCHF" || Symbol()=="EURCHFm") {symbol="EURCHF";}
   else if (Symbol()=="EURGBP" || Symbol()=="EURGBPm") {symbol="EURGBP";}
   else if (Symbol()=="USDCAD" || Symbol()=="USDCADm") {symbol="USDCAD";}
   else if (Symbol()=="AUDUSD" || Symbol()=="AUDUSDm") {symbol="AUDUSD";}
   else if (Symbol()=="GBPCHF" || Symbol()=="GBPCHFm") {symbol="GBPCHF";}
   else if (Symbol()=="GBPJPY" || Symbol()=="GBPJPYm") {symbol="GBPJPY";}
   else if (Symbol()=="CHFJPY" || Symbol()=="CHFJPYm") {symbol="CHFJPY";}
   else if (Symbol()=="NZDUSD" || Symbol()=="NZDUSDm") {symbol="NZDUSD";}
   else if (Symbol()=="EURCAD" || Symbol()=="EURCADm") {symbol="EURCAD";}
   else if (Symbol()=="AUDJPY" || Symbol()=="AUDJPYm") {symbol="AUDJPY";}
   else if (Symbol()=="EURAUD" || Symbol()=="EURAUDm") {symbol="EURAUD";}
   else if (Symbol()=="AUDCAD" || Symbol()=="AUDCADm") {symbol="AUDCAD";}
   else if (Symbol()=="AUDNZD" || Symbol()=="AUDNZDm") {symbol="AUDNZD";}
   else if (Symbol()=="NZDJPY" || Symbol()=="NZDJPYm") {symbol="NZDJPY";}
   else if (Symbol()=="CADJPY" || Symbol()=="CADJPYm") {symbol="CADJPY";}
   else if (Symbol()=="XAUUSD" || Symbol()=="XAUUSDm") {symbol="XAUUSD";}
   else if (Symbol()=="XAGUSD" || Symbol()=="XAGUSDm") {symbol="XAGUSD";}
   else if (Symbol()=="GBPAUD" || Symbol()=="GBPAUDm") {symbol="GBPAUD";}
   else if (Symbol()=="GBPCAD" || Symbol()=="GBPCADm") {symbol="GBPCAD";}
   else if (Symbol()=="AUFCHF" || Symbol()=="AUFCHFm") {symbol="AUFCHF";}
   else if (Symbol()=="CADCHF" || Symbol()=="CADCHFm") {symbol="CADCHF";}
   else if (Symbol()=="NZDCHF" || Symbol()=="NZDCHFm") {symbol="NZDCHF";}
   else if (Symbol()=="GBPNZD" || Symbol()=="GBPNZDm") {symbol="GBPNZD";}
   else if (Symbol()=="AUDCHF" || Symbol()=="AUDCHFm") {symbol="AUDCHF";}
   else if (Symbol()=="EURNZD" || Symbol()=="EURNZDm") {symbol="EURNZD";}
   else{symbol=Symbol();int syblsize = 5;int syblshift=2;}
   
   CreateFX3_Labels( "Panel014",9-syblshift+Shift.up.down,30); 
   ObjectSetText("Panel014", symbol , 22-syblsize, BidFontType, color4);
       
// ------------------------------------------------------------------------------------------ //

   CreateFX3_Labels( "Panel015",10,180); 
   ObjectSetText("Panel015", "gggg", 23, "Webdings", BoxColor1);
   CreateFX3_Labels( "Panel016",10,214); 
   ObjectSetText("Panel016", "gggg", 23, "Webdings", BoxColor1);
   CreateFX3_Labels( "Panel017",10,248); 
   ObjectSetText("Panel017", "gggg", 23, "Webdings", BoxColor1);
   
   CreateFX3_Labels( "Panel018",11+Shift.up.down,263); 
   ObjectSetText("Panel018", "Account Balance", FontSize, FontType2, color2);

   CreateFX3_Labels( "Panel019",20+Shift.up.down,248); 
   ObjectSetText("Panel019", DoubleToStr(AccountBalance(),2) , FontSize, FontType2, color3);
   
   CreateFX3_Labels( "Panel020",18+Shift.up.down,228); 
   ObjectSetText("Panel020", "Account Equity", FontSize, FontType2, color2);
   
   CreateFX3_Labels( "Panel021",20+Shift.up.down,214); 
   ObjectSetText("Panel021", DoubleToStr(AccountEquity(),2) , FontSize, FontType2, color3);
   
   CreateFX3_Labels( "Panel022",20+Shift.up.down,194); 
   ObjectSetText("Panel022", "Account Profit", FontSize, FontType2, color2);
      
   if (AccountProfit() >0) col = Lime;
   if (AccountProfit() <0) col = Red;
  
   CreateFX3_Labels( "Panel023",20+Shift.up.down,180); 
   ObjectSetText("Panel023", DoubleToStr(AccountProfit(),2) , FontSize, FontType2, col);
       
// ------------------------------------------------------------------------------------------ //

   CreateFX3_Labels( "Panel024",10+digitshift1+Shift.up.down,66+digitshift2); 
   ObjectSetText("Panel024", DoubleToStr(Bid, DecNos), BidFontSize-fontsize, BidFontType, color1);
   
// ------------------------------------------------------------------------------------------ //

   int Bar.Hour = Time[0] + 60 * Period() - TimeCurrent();
   double ld_0 = Bar.Hour / 60.0;
   int Bar.Sec = Bar.Hour % 60;
   Bar.Hour = (Bar.Hour - Bar.Hour % 60) / 60;
   
   if(Bar.Sec<=9)string zero="0";
   if(Bar.Hour>=1 && Bar.Hour<=9)int shift=-1;
   else if(Bar.Hour>=10 && Bar.Hour<=99)shift=-6;
   else if(Bar.Hour>=100 && Bar.Hour<=999)shift=-15;
   else if(Bar.Hour>=1000 && Bar.Hour<=9999)shift=-16;
   else if(Bar.Hour>=10000 && Bar.Hour<=99999)shift=-19;
   
   CreateFX3_Labels( "Panel025",40+shift,160); 
   ObjectSetText("Panel025", "t-" + Bar.Hour + ":"+zero+"" + Bar.Sec, 13, "Verdana Bold", White);
   
// ------------------------------------------------------------------------------------------ //      
      
   {  string BarTime="", LastBarTime="";         
   string BarDay="", LastBarDay="";
   int CloseBar;
          
   for(int i=Bars; i>=0; i--)
   {  if (Period() > 60) return(0);		//Chart cannot be higher than H4
   BarTime = TimeToStr(Time[i], TIME_MINUTES);
   LastBarTime = TimeToStr(Time[i+1], TIME_MINUTES);
   BarDay = TimeToStr(Time[i],TIME_DATE);
   LastBarDay = TimeToStr(Time[i+1],TIME_DATE); 
      
   if ((FiboEnd == "02:00" && BarTime>=FiboEnd && BarDay>LastBarDay) || (BarTime>=FiboEnd && LastBarTime<FiboEnd))
   {  CloseBar = i + 1;
         
   if (OpenBar>0)
   {  calculatePivotRangeValues(OpenBar, CloseBar);  }  }
      
   if ((FiboStart == "02:00" && BarTime>=FiboStart && BarDay>LastBarDay) || (BarTime>=FiboStart && LastBarTime<FiboStart))
   { OpenBar = i; }   
   }   
      
   CreateFX3_Labels( "Panel026",10,134); 
   ObjectSetText("Panel026", "ggggg", 18, "Webdings", C'5,20,40');//C'7,20,40');
   CreateFX3_Labels( "Panel027",10,121); 
   ObjectSetText("Panel027", "ggggg", 18, "Webdings", C'5,20,40');
   
   CreateFX3_Labels( "Panel028",18+digitshift+Shift.up.down,142); 
   ObjectSetText("Panel028", "D a i l y  F i b o", 10, "Verdana Bold", color2);
   
   fibo = 100*(Bid-LastLow)/(LastHigh-LastLow);
   
   CreateFX3_Labels( "Panel029",25+digitshift+Shift.up.down,122); 
   ObjectSetText("Panel029", DoubleToStr(fibo,2)+"%", 14, "Verdana Bold", White);

   CreateFX3_Labels( "Panel030",27+digitshift+Shift.up.down,105); 
   ObjectSetText("Panel030", "YHigh:"+DoubleToStr(LastHigh,DecNos), FontSize, FontType, color2);
   
   CreateFX3_Labels( "Panel031",30+digitshift+Shift.up.down,59); 
   ObjectSetText("Panel031", "YLow:"+DoubleToStr(LastLow,DecNos), FontSize, FontType, color2);
                
// ------------------------------------------------------------------------------------------ //
  
   }
   return(0);  
}
   int CreateFX1_Labels( string b, int x, int y ) {
   ObjectCreate( b, OBJ_LABEL, WhatWindow, 0, 0 );
   ObjectSet( b, OBJPROP_CORNER, WhatCorner1 );
   ObjectSet( b, OBJPROP_XDISTANCE,x+Shift.up.down);
   ObjectSet( b, OBJPROP_YDISTANCE,y+Shift.sideway);
   ObjectSet( b, OBJPROP_BACK, false );
   }
   
   int CreateFX3_Labels( string c, int x2, int y2 ) {
   ObjectCreate( c, OBJ_LABEL, WhatWindow, 0, 0 );
   ObjectSet( c, OBJPROP_CORNER, WhatCorner3 );
   ObjectSet( c, OBJPROP_XDISTANCE,x2+Shift.up.down);
   ObjectSet( c, OBJPROP_YDISTANCE,y2+Shift.sideway);
   ObjectSet( c, OBJPROP_BACK, false );
   }
  
   void deleteObjects(){
   
   ObjectDelete("Panel001");
   ObjectDelete("Panel002");
   ObjectDelete("Panel003");
   ObjectDelete("Panel004");
   ObjectDelete("Panel005");
   ObjectDelete("Panel006");
   ObjectDelete("Panel007");
   ObjectDelete("Panel008");
   ObjectDelete("Panel009");
   ObjectDelete("Panel010");
   ObjectDelete("Panel011");
   ObjectDelete("Panel012");
   ObjectDelete("Panel013");
   ObjectDelete("Panel014");
   ObjectDelete("Panel015");
   ObjectDelete("Panel016");
   ObjectDelete("Panel017");
   ObjectDelete("Panel018");
   ObjectDelete("Panel019");
   ObjectDelete("Panel020");
   ObjectDelete("Panel021");
   ObjectDelete("Panel022");
   ObjectDelete("Panel023");
   ObjectDelete("Panel024");
   ObjectDelete("Panel025");
   ObjectDelete("Panel026");
   ObjectDelete("Panel027");
   ObjectDelete("Panel028");
   ObjectDelete("Panel029");
   ObjectDelete("Panel030");
   ObjectDelete("Panel031");   
   }
    
   void calculatePivotRangeValues(int openBar, int closeBar)
   {
   LastHigh = High[Highest(NULL, 0, MODE_HIGH, (openBar - closeBar + 1), closeBar)];
   LastLow = Low[Lowest(NULL, 0, MODE_LOW, (openBar - closeBar + 1), closeBar)];
   LastClose = Close[closeBar];
   }
// ------------------------------------------------------------------------------------------ //
//                                     E N D   P R O G R A M                                  //
// ------------------------------------------------------------------------------------------ //
/*                                                         
                                        ud$$$**BILLION$bc.                          
                                    u@**"        PROJECT$$Nu                       
                                  J                ""#$$$$$$r                     
                                 @                       $$$$b                    
                               .F                        ^*3$$$                   
                              :% 4                         J$$$N                  
                              $  :F                       :$$$$$                  
                             4F  9                       J$$$$$$$                 
                             4$   k             4$$$$bed$$$$$$$$$                 
                             $$r  'F            $$$$$$$$$$$$$$$$$r                
                             $$$   b.           $$$$$$$$$$$$$$$$$N                
                             $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
              .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
              :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
             @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
             $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
             $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
              ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
                 ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
                      ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
                        ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                          '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                             #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                               "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                                 "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                                   ?k         ?$$$$$$$$$$$F'*                     
                                    9$$bL     z$$$$$$$$$$$F                       
                                     $$$$    $$$$$$$$$$$$$                        
                                      '#$$c  '$$$$$$$$$"                          
                                       .@"#$$$$$$$$$$$$b                          
                                     z*      $$$$$$$$$$$$N.                       
                                   e"      z$$"  #$$$k  '*$$.                     
                                .u*      u@$P"      '#$$c   "$$c                   
                        u@$*"""       d$$"            "$$$u  ^*$$b.               
                      :$F           J$P"                ^$$$c   '"$$$$$$bL        
                     d$$  ..      @$#                      #$$b         '#$       
                     9$$$$$$b   4$$                          ^$$k         '$      
                      "$$6""$b u$$                             '$    d$$$$$P      
                        '$F $$$$$"                              ^b  ^$$$$b$       
                         '$W$$$$"                                'b@$$$$"         
                                                                  ^$$$*/     