
// +----------------------------------------------------------------------------------------+ //
// |    .-._______                           XARD777                          _______.-.    | //
// |---( )_)______)                 Knowledge of the ancients                (______(_( )---| //
// |  (    ()___)                              \/                             (___()    )  | //
// |       ()__)                              (o o)                             (__()       | //
// |--(___()_)__________________________oOOo___(_)___oOOo_________________________(_()___)--| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                   2011 | //
// |----------------------------------------------------------------------------------------| //
// |                 File:     !BDP PROFIT.mq4                                              | //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 229 (current version)                              | //
// |                                                               [BILLION DOLLAR PROJECT] | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

extern int Corner=1;
extern int Window=0;
extern color Warna_Text       = Snow;//Gold;
extern color Warna_Order_Sell = Crimson;//C'200,50,50';
extern color Warna_Order_Buy  = LimeGreen;//C'50,160,50';
extern color Warna_Rugi       = Crimson;//C'200,50,50';
extern color Warna_Laba       = LimeGreen;//C'50,160,50';
extern string NamaFont        = "Verdana Bold";
extern int    UkuranFont      = 10;
extern double posX            = 48;
extern double posY            = 194;

// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //



int Font=9;
int x = NULL;

// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init()
  {
//---- indicators
//----
   return(0);
  }

// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

int deinit()
  {
//----
   int    idx;

   if(x != NULL) {
      for(idx = 0; idx<x; idx++) {
         ObjectDelete("Panel042"+idx);
         ObjectDelete("PL"+idx);
      }
            
      ObjectDelete("h");      
      ObjectDelete("Total1");
      ObjectDelete("Total2");

   }
   
   ObjectsDeleteAll(0,OBJ_HLINE);
   ObjectsDeleteAll(0,OBJ_TEXT);
   ObjectsDeleteAll(0,OBJ_LABEL); 

//----
   return(0);
  }
  
void DisplayText(string objname, string text, int fontsize, color clr, double C, double X, double Y, string font)
{
   ObjectDelete(objname);
   ObjectCreate(objname, OBJ_LABEL, Window, 0, 0);
   ObjectSetText(objname, text, fontsize, font, clr);
   ObjectSet(objname, OBJPROP_CORNER, Corner);
   ObjectSet(objname, OBJPROP_XDISTANCE, X+posX);
   ObjectSet(objname, OBJPROP_YDISTANCE, Y+posY);
}
  
// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

int start()
  {
 
   int    counted_bars=IndicatorCounted();
   int    j;
   int    idx;
   string text;
   double PL;
   double total;
//----
         if(x != NULL) {
            for(idx = 0; idx<x; idx++) {
               ObjectDelete("Panel042"+idx);
               ObjectDelete("Panel043"+idx);
            }
            
            ObjectDelete("Total1");
            ObjectDelete("Total2");
         }
            
         text = "";
         j=0;
         total = 0;
         
            
         DisplayText("Panel041", "Profit & Loss Info", Font, Warna_Text, 0, -36, 20 , NamaFont); 
   
         for (int i = OrdersTotal()-1 ; i >= 0; i--) 
         { 
            if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true)
            { 
               
               if(OrderType() == OP_BUY)  {
               
                  DisplayText("Panel042"+j, OrderSymbol() + "      ", Font, Warna_Order_Buy, 0, 10, Font+26 + j * 18, "Arial Bold"); 
                  PL = (OrderClosePrice()-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT)/10;
                  total = total + PL;
                  if(PL<0) DisplayText("Panel043"+j, DoubleToStr(PL, 0)+" pips", Font, Warna_Rugi, 0, -30, Font+26 + j * 18, "Arial Bold"); 
                  else if(PL>0) DisplayText("Panel043"+j, "+"+DoubleToStr(PL, 0)+" pips", Font, Warna_Laba, 0, -30, Font+26 + j * 18, "Arial Bold"); 
                  else DisplayText("Panel043"+j, DoubleToStr(PL, 0)+" pips", Font, Warna_Text, 0, -30, Font+26 + j * 18, "Arial Bold"); 
               }
               else if(OrderType() == OP_SELL)  {
                  
                  DisplayText("Panel042"+j, OrderSymbol() + "      ", Font, Warna_Order_Sell, 0, 10, Font+26 + j * 18, "Arial Bold"); 
                  PL = (OrderOpenPrice()-OrderClosePrice())/MarketInfo(OrderSymbol(),MODE_POINT)/10;
                  total = total + PL;
                  if(PL<0) DisplayText("Panel043"+j, DoubleToStr(PL, 0)+" pips" , Font, Warna_Rugi, 0, -30, Font+26 + j * 18, "Arial Bold"); 
                  else if(PL>0) DisplayText("Panel043"+j,"+"+DoubleToStr(PL, 0)+" pips" , Font, Warna_Laba, 0, -30, Font+26 + j * 18, "Arial Bold"); 
                  else DisplayText("Panel043"+j,DoubleToStr(PL, 0)+" pips" , Font, Warna_Text, 0, -30, Font+26 + j * 18, "Arial Bold"); 
               }
               j=j+1;
            } 
         } 
   
         DisplayText("Total1","Total          ", Font, Warna_Text, 0, 10, Font+24 + j * 18, "Arial Bold");
   
         if(total<0) DisplayText("Total2", DoubleToStr(total, 0)+" pips" , Font, Warna_Rugi, 0, -30, Font+24 + j * 18, "Arial Bold");
         else if (total>0) DisplayText("Total2","+" + DoubleToStr(total, 0)+" pips" , Font, Warna_Laba, 0, -30, Font+24 + j * 18, "Arial Bold");
         else DisplayText("Total2", DoubleToStr(total, 0)+" pips" , Font, White, 0, -30, Font+24 + j * 18, "Arial Bold");
                
         x=j;
   
   return(0);
  }
// ------------------------------------------------------------------------------------------ //
//                                     E N D   P R O G R A M                                  //
// ------------------------------------------------------------------------------------------ //
/*                                                         
                                        ud$$$**BILLION$bc.                          
                                    u@**"        PROJECT$$Nu                       
                                  J                ""#$$$$$$r                     
                                 @                       $$$$b                    
                               .F                        ^*3$$$                   
                              :% 4                         J$$$N                  
                              $  :F                       :$$$$$                  
                             4F  9                       J$$$$$$$                 
                             4$   k             4$$$$bed$$$$$$$$$                 
                             $$r  'F            $$$$$$$$$$$$$$$$$r                
                             $$$   b.           $$$$$$$$$$$$$$$$$N                
                             $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
              .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
              :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
             @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
             $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
             $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
              ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
                 ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
                      ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
                        ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                          '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                             #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                               "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                                 "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                                   ?k         ?$$$$$$$$$$$F'*                     
                                    9$$bL     z$$$$$$$$$$$F                       
                                     $$$$    $$$$$$$$$$$$$                        
                                      '#$$c  '$$$$$$$$$"                          
                                       .@"#$$$$$$$$$$$$b                          
                                     z*      $$$$$$$$$$$$N.                       
                                   e"      z$$"  #$$$k  '*$$.                     
                                .u*      u@$P"      '#$$c   "$$c                   
                        u@$*"""       d$$"            "$$$u  ^*$$b.               
                      :$F           J$P"                ^$$$c   '"$$$$$$bL        
                     d$$  ..      @$#                      #$$b         '#$       
                     9$$$$$$b   4$$                          ^$$k         '$      
                      "$$6""$b u$$                             '$    d$$$$$P      
                        '$F $$$$$"                              ^b  ^$$$$b$       
                         '$W$$$$"                                'b@$$$$"         
                                                                  ^$$$*/     